ICU 54.1 54.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Data Structures
Here are the data structures with brief descriptions:
[detail level 1 2 3]

icu | File coll.h
Appendable | Base class for objects to which Unicode characters and strings can be appended
UnicodeStringAppendable | An Appendable implementation which writes to a UnicodeString
BreakIterator | Implements methods for finding the location of boundaries in text
ByteSink | A ByteSink can be filled with bytes
CheckedArrayByteSink | Implementation of ByteSink that writes to a flat byte array, with bounds-checking: This sink will not write more than capacity bytes to outbuf
StringByteSink | Implementation of ByteSink that writes to a "string"
BytesTrie | Light-weight, non-const reader class for a BytesTrie
Iterator | Iterator for all of the (byte sequence, value) pairs in a BytesTrie
State | BytesTrie state object, for saving a trie's current state and resetting the trie back to this state later
BytesTrieBuilder | Builder class for BytesTrie
CanonicalIterator | This class allows one to iterate through all the strings that are canonically equivalent to a given string
ForwardCharacterIterator | Abstract class that defines an API for forward-only iteration on text objects
CharacterIterator | Abstract class that defines an API for iteration on text objects
DateInterval | This class represents a date interval
EnumSet | Enum bitset for boolean fields
ErrorCode | Wrapper class for UErrorCode, with conversion operators for direct use in ICU C and C++ APIs
IDNA | Abstract base class for IDNA processing
IDNAInfo | Output container for IDNA processing errors
ListFormatData |
ListFormatter | An immutable class for formatting a list, using data from CLDR (or supplied separately)
LocalPointerBase | "Smart pointer" base class; do not use directly: use LocalPointer etc
LocalPointer | "Smart pointer" class, deletes objects via the standard C++ delete operator
LocalArray | "Smart pointer" class, deletes objects via the C++ array delete[] operator
Locale | A `Locale` object represents a specific geographical, political, or cultural region
MessagePattern | Parses and represents ICU MessageFormat patterns
Part | A message pattern "part", representing a pattern parsing event
Normalizer2 | Unicode normalization functionality for standard Unicode normalization or for using custom mapping tables
FilteredNormalizer2 | Normalization filtered by a UnicodeSet
Normalizer | Supports the standard normalization forms described in Unicode Standard Annex #15: Unicode Normalization Forms
ParsePosition | `ParsePosition` is a simple class used by `Format` and its subclasses to keep track of the current position during parsing
RuleBasedBreakIterator | A subclass of BreakIterator whose behavior is specified using a list of rules
Replaceable | `Replaceable` is an abstract base class representing a string of characters that supports the replacement of a range of itself with a new string of characters
ResourceBundle | A class representing a collection of resource information pertaining to a given locale
StringCharacterIterator | A concrete subclass of CharacterIterator that iterates over the characters (code units or code points) in a UnicodeString
StringEnumeration | Base class for 'pure' C++ implementations of uenum api
StringPiece | A string-like object that points to a sized piece of memory
StringTrieBuilder | Base class for string trie builder classes
BranchHeadNode |
BranchNode |
FinalValueNode |
IntermediateValueNode |
LinearMatchNode |
ListBranchNode |
Node |
SplitBranchNode |
ValueNode |
SymbolTable | An interface that defines both lookup protocol and parsing of symbolic names
UCharsTrie | Light-weight, non-const reader class for a UCharsTrie
Iterator | Iterator for all of the (string, value) pairs in a UCharsTrie
State | UCharsTrie state object, for saving a trie's current state and resetting the trie back to this state later
UCharsTrieBuilder | Builder class for UCharsTrie
UCharCharacterIterator | A concrete subclass of CharacterIterator that iterates over the characters (code units or code points) in a UChar array
UnicodeFilter | `UnicodeFilter` defines a protocol for selecting a subset of the full range (U+0000 to U+10FFFF) of Unicode characters
UnicodeFunctor | `UnicodeFunctor` is an abstract base class for objects that perform match and/or replace operations on Unicode strings
UnicodeMatcher | `UnicodeMatcher` defines a protocol for objects that can match a range of characters in a Replaceable string
UnicodeSet | A mutable set of Unicode characters and multicharacter strings
UnicodeString | UnicodeString is a string class that stores Unicode characters directly and provides similar functionality as the Java String and StringBuffer classes
UMemory | UMemory is the common ICU base class
UObject | UObject is the common ICU "boilerplate" class
UnicodeSetIterator | UnicodeSetIterator iterates over the contents of a UnicodeSet
AlphabeticIndex | AlphabeticIndex supports the creation of a UI index appropriate for a given language
Bucket | An index "bucket" with a label string and type
ImmutableIndex | Immutable, thread-safe version of AlphabeticIndex
Record | A (name, data) pair, to be sorted by name into one of the index buckets
BasicTimeZone | `BasicTimeZone` is an abstract class extending `TimeZone`
Calendar | `Calendar` is an abstract base class for converting between a `UDate` object and a set of integer fields such as `YEAR`, `MONTH`, `DAY`, `HOUR`, and so on
ChoiceFormat | ChoiceFormat converts between ranges of numeric values and strings for those ranges
CollationElementIterator | Used as an iterator to walk through each character of an international string
Collator | The `Collator` class performs locale-sensitive string comparison
CollatorFactory | A factory, used with registerFactory, the creates multiple collators and provides display names for them
CompactDecimalFormat | The CompactDecimalFormat produces abbreviated numbers, suitable for display in environments will limited real estate
CurrencyAmount | A currency together with a numeric amount, such as 200 USD
CurrencyPluralInfo | This class represents the information needed by DecimalFormat to format currency plural, such as "3.00 US dollars" or "1.00 US dollar"
CurrencyUnit | A unit of currency, such as USD (U.S
DateFormat | DateFormat is an abstract class for a family of classes that convert dates and times from their internal representations to textual form and back again in a language-independent manner
DecimalFormatSymbols | This class represents the set of symbols needed by DecimalFormat to format numbers
DecimalFormat | DecimalFormat is a concrete subclass of NumberFormat that formats decimal numbers
DateFormatSymbols | DateFormatSymbols is a public class for encapsulating localizable date-time formatting data – including timezone data
DateIntervalFormat | DateIntervalFormat is a class for formatting and parsing date intervals in a language-independent manner
DateIntervalInfo | DateIntervalInfo is a public class for encapsulating localizable date time interval patterns
DateTimePatternGenerator | This class provides flexible generation of date format patterns, like "yy-MM-dd"
DateTimeRule | `DateTimeRule` is a class representing a time in a year by a rule specified by month, day of month, day of week and time in the day
FieldPosition | `FieldPosition` is a simple class used by `Format` and its subclasses to identify fields in formatted output
FilteredBreakIteratorBuilder | The BreakIteratorFilter is used to modify the behavior of a BreakIterator by constructing a new BreakIterator which suppresses certain segment boundaries
Formattable | Formattable objects can be passed to the Format class or its subclasses for formatting
Format | Base class for all formats
FieldPositionIterator | FieldPositionIterator returns the field ids and their start/limit positions generated by a call to Format::format
GenderInfo | GenderInfo computes the gender of a list as a whole given the gender of each element
GregorianCalendar | Concrete class which provides the standard calendar used by most of the world
LocaleDisplayNames | Returns display names of Locales and components of Locales
MeasureFormat | A formatter for measure objects
MeasureUnit | A unit such as length, mass, volume, currency, etc
Measure | An amount of a specified unit, consisting of a number and a Unit
MessageFormat |
NumberFormat | Abstract base class for all number formats
NumberFormatFactory | A NumberFormatFactory is used to register new number formats
SimpleNumberFormatFactory | A NumberFormatFactory that supports a single locale
NumberingSystem | Defines numbering systems
PluralFormat |
PluralSelector |
PluralSelectorAdapter |
PluralRules | Defines rules for mapping non-negative numeric values onto a small set of keywords
RuleBasedNumberFormat | Formats numbers according to a set of rules
RuleBasedTimeZone | BasicTimeZone subclass implemented in terms of InitialTimeZoneRule and TimeZoneRule instances
RegexPattern | Class `RegexPattern` represents a compiled regular expression
RegexMatcher | Class RegexMatcher bundles together a regular expression pattern and input text to which the expression can be applied
Region | `Region` is the class representing a Unicode Region Code, also known as a Unicode Region Subtag, which is defined based upon the BCP 47 standard
RelativeDateTimeFormatter | Formats simple relative dates
ScientificFormatHelper | A helper class for formatting numbers in standard scientific notation instead of E notation
SearchIterator | `SearchIterator` is an abstract base class that provides methods to search for a pattern within a text string
SelectFormat |
SimpleTimeZone | `SimpleTimeZone` is a concrete subclass of `TimeZone` that represents a time zone for use with a Gregorian calendar
SimpleDateFormat | SimpleDateFormat is a concrete class for formatting and parsing dates in a language-independent manner
CollationKey | Collation keys are generated by the Collator class
StringSearch | `StringSearch` is a `SearchIterator` that provides language-sensitive text searching based on the comparison rules defined in a RuleBasedCollator object
RuleBasedCollator | Implementation of Collator, using data-driven tables
TimeZone | `TimeZone` represents a time zone offset, and also figures out daylight savings
TimeUnit | Measurement unit for time units
TimeUnitAmount | Express a duration as a time unit and number
TimeUnitFormat | Format or parse a TimeUnitAmount, using plural rules for the units where available
Transliterator | `Transliterator` is an abstract class that transliterates text from one format to another
Token | A context integer or pointer for a factory function, passed by value
TimeZoneFormat | `TimeZoneFormat` supports time zone display name formatting and parsing
TimeZoneNames | `TimeZoneNames` is an abstract class representing the time zone display name data model defined by UTS#35 Unicode Locale Data Markup Language (LDML)
MatchInfoCollection | `MatchInfoCollection` represents a collection of time zone name matches used by TimeZoneNames#find
TimeZoneRule | `TimeZoneRule` is a class representing a rule for time zone
InitialTimeZoneRule | `InitialTimeZoneRule` represents a time zone rule representing a time zone effective from the beginning and has no actual start times
AnnualTimeZoneRule | `AnnualTimeZoneRule` is a class used for representing a time zone rule which takes effect annually
TimeArrayTimeZoneRule | `TimeArrayTimeZoneRule` represents a time zone rule whose start times are defined by an array of milliseconds since the standard base time
TimeZoneTransition | `TimeZoneTransition` is a class representing a time zone transition
UnicodeReplacer | `UnicodeReplacer` defines a protocol for objects that replace a range of characters in a Replaceable string with output text
VTimeZone | `VTimeZone` is a class implementing RFC2445 VTIMEZONE
LECharMapper | Instances of this class are used by `LEFontInstance::mapCharsToGlyphs` and `LEFontInstance::mapCharToGlyph` to adjust character codes before the character to glyph mapping process
LEFontInstance | This is a virtual base class that serves as the interface between a LayoutEngine and the platform font environment
LEGlyphStorage | This class encapsulates the per-glyph storage used by the ICU LayoutEngine
LESwaps | This class is used to access data which stored in big endian order regardless of the conventions of the platform
LayoutEngine | NOTE: This class is deprecated, please instead use HarfBuzz
ParagraphLayout | ParagraphLayout
Line | This class represents a single line of text in a `ParagraphLayout`
VisualRun | This object represents a single visual run in a line of text in a paragraph
RunArray | The `RunArray` class is a base class for building classes which represent data that is associated with runs of text
FontRuns | The `FontRuns` class associates pointers to `LEFontInstance` objects with runs of text
LocaleRuns | The `LocaleRuns` class associates pointers to `Locale` objects with runs of text
ValueRuns | The `ValueRuns` class associates integer values with runs of text
LEPoint | Used to hold a pair of (x, y) values which represent a point
LocalUBiDiPointer | "Smart pointer" class, closes a UBiDi via ubidi_close()
LocalUBreakIteratorPointer | "Smart pointer" class, closes a UBreakIterator via ubrk_close()
LocalUCalendarPointer | "Smart pointer" class, closes a UCalendar via ucal_close()
LocalUCaseMapPointer | "Smart pointer" class, closes a UCaseMap via ucasemap_close()
LocalUCharsetDetectorPointer | "Smart pointer" class, closes a UCharsetDetector via ucsdet_close()
LocalUCollatorPointer | "Smart pointer" class, closes a UCollator via ucol_close()
LocalUConverterPointer | "Smart pointer" class, closes a UConverter via ucnv_close()
LocalUConverterSelectorPointer | "Smart pointer" class, closes a UConverterSelector via ucnvsel_close()
LocalUDataMemoryPointer | "Smart pointer" class, closes a UDataMemory via udata_close()
LocalUDateFormatPointer | "Smart pointer" class, closes a UDateFormat via udat_close()
LocalUDateIntervalFormatPointer | "Smart pointer" class, closes a UDateIntervalFormat via udtitvfmt_close()
LocalUDateTimePatternGeneratorPointer | "Smart pointer" class, closes a UDateTimePatternGenerator via udatpg_close()
LocalUEnumerationPointer | "Smart pointer" class, closes a UEnumeration via uenum_close()
LocalUFILEPointer | "Smart pointer" class, closes a UFILE via u_fclose()
LocalUFormattablePointer | "Smart pointer" class, closes a UFormattable via ufmt_close()
LocalUIDNAPointer | "Smart pointer" class, closes a UIDNA via uidna_close()
LocalULocaleDataPointer | "Smart pointer" class, closes a ULocaleData via ulocdata_close()
LocalULocaleDisplayNamesPointer | "Smart pointer" class, closes a ULocaleDisplayNames via uldn_close()
LocalUMessageFormatPointer | "Smart pointer" class, closes a UMessageFormat via umsg_close()
LocalUNormalizer2Pointer | "Smart pointer" class, closes a UNormalizer2 via unorm2_close()
LocalUNumberFormatPointer | "Smart pointer" class, closes a UNumberFormat via unum_close()
LocalUNumberingSystemPointer | "Smart pointer" class, closes a UNumberingSystem via unumsys_close()
LocalUPluralRulesPointer | "Smart pointer" class, closes a UPluralRules via uplrules_close()
LocalURegularExpressionPointer | "Smart pointer" class, closes a URegularExpression via uregex_close()
LocalUResourceBundlePointer | "Smart pointer" class, closes a UResourceBundle via ures_close()
LocalUSetPointer | "Smart pointer" class, closes a USet via uset_close()
LocalUSpoofCheckerPointer | "Smart pointer" class, closes a USpoofChecker via uspoof_close()
LocalUStringPrepProfilePointer | "Smart pointer" class, closes a UStringPrepProfile via usprep_close()
LocalUStringSearchPointer | "Smart pointer" class, closes a UStringSearch via usearch_close()
LocalUTextPointer | "Smart pointer" class, closes a UText via utext_close()
LocalUTransliteratorPointer | "Smart pointer" class, closes a UTransliterator via utrans_close()
UCharIterator | C API for code unit iteration
UConverterFromUnicodeArgs | The structure for the fromUnicode callback function parameter
UConverterToUnicodeArgs | The structure for the toUnicode callback function parameter
UDataInfo | UDataInfo contains the properties about the requested data
UFieldPosition | A struct representing a range of text containing a specific field
UIDNAInfo | Output container for IDNA processing errors
UParseError | A UParseError struct is used to returned detailed information about parsing errors
UReplaceableCallbacks | A set of function pointers that transliterators use to manipulate a UReplaceable
USerializedSet | A serialized form of a Unicode set
UText | UText struct
UTextFuncs | (public) Function dispatch table for UText
UTransPosition | Position structure for utrans_transIncremental() incremental transliteration